
###########################################################################
#
#   Copyright (c) 2000 Morten W. Petersen <morten@esol.no>
#	Copyright (c) 2000 Thingamy Ltd.
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, 
#    MA 02111-1307 USA
#
#
###########################################################################

# $Author: morten $
# $Revision: 1.11 $


__doc__ = 'Documentation string.'
__version__ = '0.1.0'

from Globals import HTMLFile
from Globals import Persistent
from Globals import default__class_init__
import Acquisition
import AccessControl.Role
import Products
import OFS.Folder
import attachment
import base_item


message_add_redirect = HTMLFile('message_add_redirect', globals())
manage_add_message_form = HTMLFile('message_add', globals())


def manage_add_message(self, id, to, reply_to, cc, bcc, newsgroups, body, REQUEST=None):
    "Add an instance of the message class"

    self._setObject(id, message(id, to, reply_to, cc, bcc, newsgroups, body))

    if REQUEST is not None:

        return self.manage_main(self, REQUEST)


class message(
	Products.ZCatalog.CatalogAwareness.CatalogAware,
	OFS.Folder.Folder,
	Persistent,
	Acquisition.Implicit,
	AccessControl.Role.RoleManager,
	base_item.base_item
	):
	"Documentation string"

	meta_type = 'Message'
	icon = 'misc_/Transform/Folder_icon.gif'

	_properties = (
		{'id':'sender', 'type':'string'},
		{'id':'to', 'type':'list'},
		{'id':'reply_to', 'type':'list'},
		{'id':'cc', 'type':'list'},
		{'id':'bcc', 'type':'list'},
		{'id':'newsgroups', 'type':'list'},
		{'id':'body', 'type':'text'},
		)

	meta_types = (
		{'name':'Attachment', 'action':'manage_add_attachment_form'},
		)

	manage_add_attachment_form = attachment.manage_add_attachment_form
	manage_add_attachment = attachment.manage_add_attachment
	attachment_add_redirect = attachment.attachment_add_redirect

	__ac_permissions__ = (
		('View management screens',
		 ('manage_tabs', 'manage_main')),
		('Change Permissions',
		 ('manage_access',)),
		('Add Attachment',
		 ('manage_add_attachment', 'manage_add_attachment_form')),
		('View Messages',
		 ('',)),
		)

	index_html = HTMLFile('message_index', globals())


	def __init__(self, id, to=[], reply_to=[], cc=[], bcc=[], newsgroups=[], body=''):
		"Initialize the class instance"

		self.id = id
		self.to = to
		self.reply_to = reply_to
		self.cc = cc
		self.bcc = bcc
		self.newsgroups = newsgroups
		self.body = body

		self.index_object()


default__class_init__(message)

